#include "config.h"

#include "test-parser.h"

#include <gnome-podcast.h>

#include <glib.h>

gchar *rss_sample_data = "<?xml version=\"1.0\" encoding=\"UTF-8\"?> \
<rss version=\"2.0\" xmlns:atom=\"http://www.w3.org/2005/Atom\" xmlns:cc=\"http://web.resource.org/cc/\" xmlns:rdf=\"http://www.w3.org/1999/02/22-rdf-syntax-ns#\"> \
    <channel> \
        <title>GNOME Podcast Example</title> \
        <link>protocol://domain.tld/</link> \
        <description>Example feed for libgnome-podcast tests.</description> \
 \
        <language>en-us</language> \
        <copyright>Copyright 2017, GNOME Podcast Team</copyright> \
        <managingEditor>example@domain.tld</managingEditor> \
        <webMaster>example@domain.tld</webMaster> \
        <pubDate>Sat, 09 Sep 2017 09:09:09 +0000</pubDate> \
        <lastBuildDate>Sat, 09 Sep 2017 09:09:09 +0000</lastBuildDate> \
        <category>Example</category> \
        <docs>protocol://domain.tld/docs.html</docs> \
        <image> \
            <url>protocol://domain.tld/image.ext</url> \
            <title>GNOME Podcast Example</title> \
            <link>protocol://domain.tld/</link> \
        </image> \
 \
        <item> \
            <title>#001 - Item 001</title> \
            <link>protocol://domain.tld/item/001</link> \
            <description>Example feed item for libgnome-podcast tests.</description> \
            <author>GNOME Podcast Team</author> \
            <category>Example</category> \
            <comments>protocol://domain.tld/item/001/comments</comments> \
            <enclosure url=\"protocol://domain.tld/audio/001.opus\" type=\"audio/mpeg\" length=\"99999\" /> \
            <guid>protocol://domain.tld/item/001</guid> \
            <pubDate>Sat, 09 Sep 2017 09:09:09 +0000</pubDate> \
            <source>protocol://domain.tld/rss</source> \
        </item> \
        <item> \
            <title>#002 - Item 002</title> \
            <link>protocol://domain.tld/item/002</link> \
            <description>Example feed item for libgnome-podcast tests.</description> \
            <author>GNOME Podcast Team</author> \
            <category>Example</category> \
            <comments>protocol://domain.tld/item/002/comments</comments> \
            <enclosure url=\"protocol://domain.tld/item/002/audio.opus\" type=\"audio/mpeg\" length=\"99999\" /> \
            <guid>protocol://domain.tld/item/002</guid> \
            <pubDate>Sat, 08 Sep 2017 09:09:09 +0000</pubDate> \
            <source>protocol://domain.tld/rss</source> \
        </item> \
    </channel> \
</rss>;";

void
parser_fixture_set_up (ParserFixture *fixture,
                       gconstpointer  user_data)
{
    fixture->parser = gpod_parser_new ();
}

void
parser_fixture_tear_down (ParserFixture *fixture,
                          gconstpointer  user_data)
{
    g_clear_object (&fixture->parser);
}

void
test_parser_load_data (ParserFixture *fixture,
                       gconstpointer  user_data)
{
    gboolean retval;
    GError *error = NULL;

    retval = gpod_parser_load_from_data (fixture->parser, rss_sample_data, -1, &error);

    if (error)
        g_print ("Failed to load data into parser, message: \"%s\" ", error->message);

    g_assert (retval == TRUE);
}

void
test_parser_load_file (ParserFixture *fixture,
                       gconstpointer  user_data)
{
/*
    gboolean retval;
    GError *error = NULL;

    retval = gpod_parser_load_from_file (fixture->parser,
                                         "/media/files/Software_Development/gnome-podcast/subprojects/libgnome-podcast/tests/data/feed-example.rss",
                                         &error);

    if (error)
        g_print ("Failed to load file into parser, message: \"%s\" ", error->message);

    g_assert (retval == TRUE);
*/
}

void
test_parser_parse_feed (ParserFixture *fixture,
                        gconstpointer  user_data)
{
    gboolean retval;
    GError *error = NULL;

    retval = gpod_parser_load_from_data (fixture->parser, rss_sample_data, -1, &error);

    if (error)
        g_print ("Failed to load data into parser, message: \"%s\" ", error->message);

    g_assert (retval == TRUE);

    //g_print ("Title: %s\n", gpod_parser_get_channel_title (fixture->parser));
}
